# norootforbuild
#!BuildIgnore:          post-build-checks
%define		pversion 2.0.33
%define         confdir /etc/munin
%define         libdir  /usr/share/munin
%define         htmldir /srv/www/munin
%define         cgidir  /srv/www/cgi-bin
%define         dbdir   /var/lib/munin
%define         logdir  /var/log/munin
%define         statedir /var/run/munin

Name:      	munin
Version:   	2.0.33
Release:	11.1

Summary:	Network-wide graphing framework (grapher/gatherer)
License: 	GPL
Group:		System/Monitoring
URL:		http://munin-monitoring.org/

Source0:	%{name}-%{pversion}.tar.bz2
Source1:	Makefile.config
Source2:	munin-node.rc
Source3:	munin.cron.d
Source4:	munin.logrotate
Source5:	munin-node.logrotate
Source6:	munin-node.cron.d
Source7:	plugins.conf
Source8:	munin-vhost.template
Source9:	munin-node.service

Requires:	perl-HTML-Template perl-Log-Log4perl perl(Getopt::Long) >= 2.37 rrdtool logrotate cron
Requires:	perl(Net::SSLeay)
Requires:	perl(Net::Server)
Requires:	perl(Net::SNMP)
Requires:	perl(File::Copy::Recursive)
Requires:	perl-FCGI
Requires:	perl(IO::Socket::INET6)
Requires:	perl(Date::Manip)
Requires:	perl-Munin = %{version}-%{release}
BuildArch:	noarch

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%if 0%{?suse_version}
BuildRequires:	html2text htmldoc 
%endif
BuildRequires:	perl-Module-Build perl-HTML-Template perl-Log-Log4perl perl(Getopt::Long) >= 2.37
BuildRequires:	perl(Net::SSLeay)
BuildRequires:	perl(Net::Server)
BuildRequires:	perl(Net::SNMP)
BuildRequires:	perl(File::Copy::Recursive)
BuildRequires:	perl-FCGI
BuildRequires:	perl(LWP)

%description
Munin is a highly flexible and powerful solution used to create graphs of
virtually everything imaginable throughout your network, while still
maintaining a rattling ease of installation and configuration.

This package contains the grapher/gatherer. You will only need one instance of
it in your network. It will periodically poll all the nodes in your network
it's aware of for data, which it in turn will use to create graphs and HTML
pages, suitable for viewing with your graphical web browser of choice.

Munin is written in Perl, and relies heavily on Tobi Oetiker's excellent
RRDtool. To see a real example of Munin in action, take a peek at
<http://www.linpro.no/projects/munin/example/>.


%package node

Group:		System Environment/Daemons
Summary:	Network-wide graphing framework (node)
BuildArch: 	noarch

Requires: 	ps sysstat logrotate cron
Requires:       perl(Net::SSLeay)
Requires:       perl(Net::Server)
Requires:       perl(Net::SNMP)
Requires:	perl(Net::CIDR)
Requires:	perl(Cache::Cache)
Requires:	perl(DBI)
Requires:	perl(DBD::Pg)
Requires:	perl(DBD::mysql)
Requires:	perl(LWP)
Requires:	perl-Munin = %{version}-%{release}

%description node
Munin is a highly flexible and powerful solution used to create graphs of
virtually everything imaginable throughout your network, while still
maintaining a rattling ease of installation and configuration.

This package contains node software. You should install it on all the nodes
in your network. It will know how to extract all sorts of data from the
node it runs on, and will wait for the gatherer to request this data for
further processing.

It includes a range of plugins capable of extracting common values such as
cpu usage, network usage, load average, and so on. Creating your own plugins
which are capable of extracting other system-specific values is very easy,
and is often done in a matter of minutes. You can also create plugins which
relay information from other devices in your network that can't run Munin,
such as a switch or a server running another operating system, by using
SNMP or similar technology.

Munin is written in Perl, and relies heavily on Tobi Oetiker's excellent
RRDtool. To see a real example of Munin in action, take a peek at
<http://www.linpro.no/projects/munin/example/>.


%package -n perl-Munin
Group:		System Environment/Daemons
Summary:	Network-wide graphing framework (perl modules)
BuildArch:	noarch

%description -n perl-Munin
Munin is a highly flexible and powerful solution used to create graphs of
virtually everything imaginable throughout your network, while still
maintaining a rattling ease of installation and configuration.

This package contains munins central perl modules.


%prep
%setup -q -n %{name}-%{pversion}

%build
%if 1%{?suse_version}
# htmldoc and html2text are not available for Red Hat. Quick hack with perl:
# Skip the PDFs.
perl -pi -e 's,htmldoc munin,cat munin, or s,html(2text|doc),# $&,' Makefile
perl -pi -e 's,\$\(INSTALL.+\.(pdf|txt) \$\(DOCDIR,# $&,' Makefile
%endif

make    CONFIG=%{SOURCE1} \
        DOCDIR=%{_docdir}/munin \
        MANDIR=%{_mandir} \
	HTMLDIR=%{htmldir} \
	CGIDIR=%{cgidir} \
	LIBDIR=%{libdir} \
	CONFDIR=%{confdir} \
        DESTDIR=%{buildroot} \
        DBDIR=%{dbdir} \
	DBDIRNODE=%{dbdir} \
        SBINDIR=%{_sbindir} \
        LOGDIR=%{logdir} \
        STATEDIR=%{statedir} \
	HOSTNAME=localhost \
        build

mkdir -p %{buildroot}%{dbdir}/plugin-state
mkdir -p %{buildroot}%{logdir}
mkdir -p %{buildroot}%{statedir}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/cron.d
mkdir -p %{buildroot}/etc/logrotate.d
mkdir -p %{buildroot}%{htmldir}

%install

make    CONFIG=%{SOURCE1} \
        DOCDIR=%{buildroot}%{_docdir}/munin \
        MANDIR=%{buildroot}%{_mandir} \
	HTMLDIR=%{buildroot}%{htmldir} \
	LIBDIR=%{buildroot}%{libdir} \
	CGIDIR=%{buildroot}%{cgidir} \
	CONFDIR=%{buildroot}%{confdir} \
        DESTDIR=%{buildroot} \
        DBDIR=%{buildroot}%{dbdir} \
	DBDIRNODE=%{buildroot}%{dbdir} \
        SBINDIR=%{buildroot}%{_sbindir} \
        LOGDIR=%{buildroot}%{logdir} \
        STATEDIR=%{buildroot}%{statedir} \
	install-master-prime install-common-prime install-node-prime install-plugins-prime install-man install-doc
sed -i s@"%{buildroot}"@""@g %{buildroot}%{perl_vendorlib}/Munin/Common/Defaults.pm %{buildroot}%{_docdir}/munin/resources/crontab-generic-munin

install -d %{buildroot}%{_docdir}/munin
%if 0%{?rhel} >= 7 || 0%{?sles_version} >= 12 || 0%{?suse_version} >= 1230
install -m0644 -D %{SOURCE9} %{buildroot}/usr/lib/systemd/system/munin-node.service
%else
install -m0755 -D %{SOURCE2} %{buildroot}/etc/init.d/munin-node
mkdir -p $RPM_BUILD_ROOT/sbin
ln -s ../etc/init.d/munin-node $RPM_BUILD_ROOT/sbin/rcmunin-node
%endif
install -m0644 -D %{SOURCE3} %{buildroot}/etc/cron.d/munin
install -m0644 -D %{SOURCE4} %{buildroot}/etc/logrotate.d/munin
install -m0644 %{SOURCE5} %{buildroot}/etc/logrotate.d/munin-node
install -m0644 %{SOURCE6} %{buildroot}/etc/cron.d/munin-node
install -m0644 -D %{SOURCE7} %{buildroot}%{confdir}/plugin-conf.d/munin-node
install -m0644 -D %{SOURCE8} %{buildroot}%{_sysconfdir}/apache2/vhosts.d/munin-vhost.template
install -m0644 ChangeLog %{buildroot}%{_docdir}/munin/ChangeLog
install -d %{buildroot}/var/log/munin
install -d %{buildroot}/var/lib/munin/plugin-state

%clean
%{__rm} -rf %{buildroot}

%pre
/usr/sbin/groupadd -r   munin &>/dev/null || :
/usr/sbin/useradd -o -g munin -s /bin/false -r -c "munin monitoring" -d /var/lib/munin munin &>/dev/null || :

%post
mkdir -p %{htmldir}
mkdir -p %{logdir}
mkdir -p %{dbdir}
chown -R munin:munin %{htmldir} || :
chown -R munin:munin %{logdir} || :
chown -R munin:munin %{statedir} || :
chown -R munin:munin %{dbdir} || :

## Node
%pre node
getent group munin >/dev/null || /usr/sbin/groupadd -r munin > /dev/null 2>&1 || :
getent passwd munin > /dev/null || /usr/sbin/useradd -r -d %{dbdir} -g munin munin > /dev/null 2>&1 || :

%post node
if [ $1 = 1 ]
then
	%if 0%{?rhel} >= 7 || 0%{?sles_version} >= 12 || 0%{?suse_version} >= 1230
		systemctl enable munin-node

	%else
        	/sbin/chkconfig --add munin-node
	%endif
	/usr/sbin/munin-node-configure --shell | sh
fi
%{fillup_and_insserv -n -y munin munin-node}
mkdir -p %{logdir}
mkdir -p %{dbdir}/plugin-state
chown -R munin:munin %{logdir} || :
chown -R munin:munin %{dbdir} || :
chmod g+w %{dbdir}/plugin-state || :
#/etc/init.d/munin-node status >/dev/null 2>&1 || /etc/init.d/munin-node start

%preun node
if [ $1 = 0 ]
then
	%if 0%{?rhel} >= 7 || 0%{?sles_version} >= 12 || 0%{?suse_version} >= 1230
		systemctl stop munin-node
		systemctl disable munin-node
	%else
        	/sbin/service munin-node stop > /dev/null 2>&1
	        /sbin/chkconfig --del munin-node
        	rmdir %{logdir} 2>/dev/null || true
	%endif
fi
%stop_on_removal munin-node

%postun node
%restart_on_update munin-node
%{insserv_cleanup}


%files
%defattr(-, root, root)
%doc %{_docdir}/munin/README
%doc %{_docdir}/munin/COPYING
%doc %{_docdir}/munin/ChangeLog
%doc %{_docdir}/munin/resources/crontab-generic-munin
%dir %{htmldir}
%{htmldir}/.htaccess
#%{_mandir}/man8/munin-graph*
%{_mandir}/man8/munin-update*
%{_mandir}/man8/munin-html*
%{_mandir}/man8/munin-cron*
%{_mandir}/man5/munin.conf*
%{_mandir}/man8/munin-limits.8*
%{_mandir}/man3/Munin::Common*
%{_mandir}/man3/Munin::Master*
%{_mandir}/man8/munin-check*
%{_mandir}/man8/munin.8*
%{_mandir}/man1/munindoc.1*
%{_bindir}/munin-cron
%{_bindir}/munindoc
%{_bindir}/munin-check
%{_datadir}/munin/munin-html
%{_datadir}/munin/munin-update
%{_datadir}/munin/DejaVuSans.ttf
%{_datadir}/munin/DejaVuSansMono.ttf
%{_datadir}/munin/munin-limits
%attr(0755,munin,munin) %{cgidir}/munin-cgi-graph
%config %{confdir}/templates/*
%config /etc/cron.d/munin
%config(noreplace) %{confdir}/munin.conf
%config /etc/logrotate.d/munin
%dir %{_sysconfdir}/apache2
%dir %{_sysconfdir}/apache2/vhosts.d
%config %{_sysconfdir}/apache2/vhosts.d/munin-vhost.template
%ghost %dir %{statedir}
%{_sysconfdir}/munin/static/dynazoom.html
%{_sysconfdir}/munin/static/favicon.ico
%{_sysconfdir}/munin/static/formatdate.js
%{_sysconfdir}/munin/static/logo-h.png
%{_sysconfdir}/munin/static/logo.png
%{_sysconfdir}/munin/static/querystring.js
%{_sysconfdir}/munin/static/style-1.2.css
%{_sysconfdir}/munin/static/style-new.css
%{_sysconfdir}/munin/static/style.css
%attr(0755,munin,munin) %{cgidir}/munin-cgi-html
%{_sbindir}/munin-sched
%{_mandir}/man1/munin-sched.1*
%{_datadir}/munin/munin-datafile2storable
%{_datadir}/munin/munin-storable2datafile
%{_sysconfdir}/munin/static/definitions.html
%{_sysconfdir}/munin/static/zoom.js
%{_mandir}/man8/munin-graph.8.gz
%{_datadir}/munin/munin-graph

%files node
%defattr(-, root, root)
%{_mandir}/man1/munin-run*
%{_mandir}/man1/munin-node*
%{_mandir}/man5/munin-node*
%{_mandir}/man3/Munin::Node*
%{_mandir}/man3/Munin::Plugin*
%dir /var/log/munin
%dir /var/lib/munin/plugin-state
%{_sbindir}/munin-run
%{_sbindir}/munin-node
%{_sbindir}/munin-node-configure
%{_datadir}/munin/plugins/*
%config(noreplace) %{confdir}/munin-node.conf
%config(noreplace) %{confdir}/plugin-conf.d/munin-node
%if 0%{?rhel} >= 7 || 0%{?sles_version} >= 12 || 0%{?suse_version} >= 1230
/usr/lib/systemd/system/munin-node.service
%else
%config /etc/init.d/munin-node
/sbin/rcmunin-node
%endif
%config /etc/cron.d/munin-node
%config /etc/logrotate.d/munin-node
%dir %{confdir}/plugins

%files -n perl-Munin
%defattr(-,root,root)
%{perl_vendorlib}/Munin/Common/*.pm
%{perl_vendorlib}/Munin/Master/*.pm
%{perl_vendorlib}/Munin/Plugin.pm
%{perl_vendorlib}/Munin/Node/*.pm
%{perl_vendorlib}/Munin/Node/Configure/*.pm
%{perl_vendorlib}/Munin/Plugin/*.pm

%changelog
* Fri Mar  3 2017 cs@linux-administrator.com
- Update to release 2.0.33
* Sun Nov 30 2014 cs@linux-administrator.com
- Add munin-node.service file for distributions which support it
* Sat Nov 29 2014 cs@linux-administrator.com
- Update to release 2.0.25
* Wed Nov 19 2014 cs@linux-administrator.com
- adapt build for EL7
* Mon Oct 27 2014 cs@linux-administrator.com
- Update to release 2.0.24
* Fri May  9 2014 cs@linux-administrator.com
- Update to release 2.0.21
* Sat Mar 29 2014 cs@linux-administrator.com
- Update to release 2.0.20
* Sun Dec  8 2013 cs@linux-administrator.com
- Update to release 2.0.19
* Mon Dec  2 2013 cs@linux-administrator.com
- Update to security release 2.0.18
* Wed Jul 31 2013 cs@linux-administrator.com
- Update to release 2.0.17
* Tue Jul 16 2013 cs@linux-administrator.com
- Update to release 2.0.16
* Sun May 12 2013 cs@linux-administrator.com
- Update to release 2.0.14
* Thu May  9 2013 cs@linux-administrator.com
- Update to release 2.0.13
* Fri Mar 22 2013 cs@linux-administrator.com
- Update to release 2.0.12
* Sat Feb  9 2013 cs@linux-administrator.com
- Update to release 2.0.11
* Wed Jan  9 2013 cs@linux-administrator.com
- Update to release 2.0.10
* Sat Jan  5 2013 cs@linux-administrator.com
- Update to release 2.0.9
* Wed Nov 28 2012 cs@linux-administrator.com
- Update to release 2.0.8
* Fri Nov  2 2012 cs@linux-administrator.com
- Update to release 2.0.7
* Wed Sep 12 2012 cs@linux-administrator.com
- added munin-node-os_file-path.patch
* Tue Sep 11 2012 cs@linux-administrator.com
- Update to release 2.0.6
* Sun Jun 24 2012 cs@linux-administrator.com
- Update to release 2.0.1
- fixed project URL in package
* Sun Jun 24 2012 cs@linux-administrator.com
- Last release used wrong source package
- added munin-vhost.template for apache2
* Thu Jun 14 2012 cs@linux-administrator.com
- Update to relesae 2.0.0
* Mon May 21 2012 cs@linux-administrator.com
- Update to release 2.0.0-rc6
* Tue Mar 13 2012 cs@linux-administrator.com
- Update to release 2.0.0-rc2
* Tue Sep 13 2011 cs@linux-administrator.com
- change ownership of cgi scripts to munin:munin
* Sat Sep  3 2011 cs@linux-administrator.com
- added munin-2.0-beta4-http_loadtime.patch
* Fri Sep  2 2011 cs@linux-administrator.com
- Update to release 2.0.0-beta4
* Tue Aug 16 2011 cs@linux-administrator.com
- Update to release 1.4.6
